#!/bin/bash

# Pour mettre à jour les fichiers de configuration personnelle
# sur toutes les machines où j'ai accès

color='[0;31m'
green='[0;32m'
endcolor='[0m'

# Pour l'exécuter à la maison
if [ "$1" = "--local" ]
then
    localmode=".local"
fi

# Déclaration des machines, dont celles qui dépendent du localmode
machines_behind_komaz="cerebro bde-test bde3 bde2-virt zamok rezosup"
other_machines="19.dptinfo pimeys oswaft soyouz gladys${localmode} cabal${localmode}"

# On accèdera aux machines derrière komaz via un seul proxy avec une connexion master
crans_proxy="zamok"
# Chemin de la socket pour la connexion master
socket=$(mktemp -u)

if [[ "`hostname`" != "eva" ]];
then
    echo "${green}Normalement, à exécuter sur eva !${endcolor}"
fi

echo "Les machines de Serenity sont en dernier (.local issue)"

# locally
echo "${color}sur eva:${endcolor} (localement)"
cd ~/.myconfig
git pull

# Ouverture de la connexion master vers la zone Cr@ns
ssh ${crans_proxy} -o ControlMaster=yes -o ControlPath=${socket} -o ControlPersist=yes -n &> /dev/null

for i in ${machines_behind_komaz}
do
    echo "${color}sur $i:${endcolor}"
    ssh $i -o ProxyCommand="ssh ${crans_proxy} -o ControlMaster=no -o ControlPath=${socket} -W %h:%p" 'cd .myconfig; git pull'
done

# Fermeture de la connexion master
ssh ${crans_proxy} -o ControlMaster=no -o ControlPath=${socket} -O exit


for i in ${other_machines}
do
    echo "${color}sur $i:${endcolor}"
    ssh $i 'cd .myconfig; git pull'
done

# Warning à la fin
echo "${color}Ne peut pas mettre à jour (ForwardAgent=no) :${endcolor} tahines"
